/**
 ** cc.c
 **
 ** Copyright 1990, 1991 by Randy Sargent.
 **
 ** The author hereby grants to MIT permission to use this software.
 ** The author also grants to MIT permission to distribute this software
 ** to schools for non-commercial educational use only.
 **
 ** The author hereby grants to other individuals or organizations
 ** permission to use this software for non-commercial
 ** educational use only.  This software may not be distributed to others
 ** except by MIT, under the conditions above.
 **
 ** Other than these cases, no part of this software may be used or
 ** distributed without written permission of the author.
 **
 ** Neither the author nor MIT make any representations about the 
 ** suitability of this software for any purpose.  It is provided 
 ** "as is" without express or implied warranty.
 **
 ** Randy Sargent
 ** Research Specialist
 ** MIT Media Lab
 ** 20 Ames St.  E15-301
 ** Cambridge, MA  02139
 ** E-mail:  rsargent@athena.mit.edu
 **
 **/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* What if we were a real UNIX c compiler?  Sigh. */
/* Let's play make-believe */

char buf[100];
#define BUFEND (buf + strlen(buf))

void print_arg(char *arg);

NOPROTO void main(Int argc, char **argv)
{
    Int i;
    Int link= 1;
    for (i= 1; argv[i]; i++) if (!strcmp(argv[i], "-c")) link= 0;
    buf[0]= 0;
    if (!link) {
        strcpy(BUFEND, "cl ");
        for (i= 1; argv[i]; i++) {
            print_arg(argv[i]);
        }
    }
    else {
        printf("I don't know how to link!\n");
    }
    printf("%s\n", buf);
    exit(system(buf));
}

void print_arg(char *arg)
{
    char *bufptr= BUFEND;
    *bufptr++= '"';
    while (*arg) {
        if (*arg != '\'') *bufptr++= *arg;
        arg++;
    }
    *bufptr++= '"';
    *bufptr++= ' ';
    *bufptr= 0;
}
            
