/**
 ** queue.h
 **
 ** Copyright 1990, 1991 by Randy Sargent.
 **
 ** The author hereby grants to MIT permission to use this software.
 ** The author also grants to MIT permission to distribute this software
 ** to schools for non-commercial educational use only.
 **
 ** The author hereby grants to other individuals or organizations
 ** permission to use this software for non-commercial
 ** educational use only.  This software may not be distributed to others
 ** except by MIT, under the conditions above.
 **
 ** Other than these cases, no part of this software may be used or
 ** distributed without written permission of the author.
 **
 ** Neither the author nor MIT make any representations about the 
 ** suitability of this software for any purpose.  It is provided 
 ** "as is" without express or implied warranty.
 **
 ** Randy Sargent
 ** Research Specialist
 ** MIT Media Lab
 ** 20 Ames St.  E15-301
 ** Cambridge, MA  02139
 ** E-mail:  rsargent@athena.mit.edu
 **
 **/

/**
 **  queue.h
 **
 **  Unsorted queue implemented as a ringbuffer
 **
 ** v1.0  Thu May  9 08:46:43 1991  Randy Sargent.  created
 ** v1.1  Fri May 31 22:27:25 1991  Randy Sargent.  fixed bugs
 **/

#ifndef QUEUE_H
#define QUEUE_H

typedef struct queue_str {
    Int fullness;
    Int max_size;
    Int elem_size;
    Int head;
    char *elems;
} Queue;

extern Int queue_debug;

#define QUEUE_EMPTY(q) ((q)->fullness == 0)
#define QUEUE_FULL(q)  ((q)->fullness == (q)->max_size)

#include "queue.pro"

#endif   /* #ifndef QUEUE_H */
