/**
 ** scanner.h
 **
 ** Copyright 1990, 1991 by Randy Sargent.
 **
 ** The author hereby grants to MIT permission to use this software.
 ** The author also grants to MIT permission to distribute this software
 ** to schools for non-commercial educational use only.
 **
 ** The author hereby grants to other individuals or organizations
 ** permission to use this software for non-commercial
 ** educational use only.  This software may not be distributed to others
 ** except by MIT, under the conditions above.
 **
 ** Other than these cases, no part of this software may be used or
 ** distributed without written permission of the author.
 **
 ** Neither the author nor MIT make any representations about the 
 ** suitability of this software for any purpose.  It is provided 
 ** "as is" without express or implied warranty.
 **
 ** Randy Sargent
 ** Research Specialist
 ** MIT Media Lab
 ** 20 Ames St.  E15-301
 ** Cambridge, MA  02139
 ** E-mail:  rsargent@athena.mit.edu
 **
 **/


#ifdef SCANNER_MODULE
#include "scanner_private.h"
#endif

/*-------------------------------------------------------------------------*/
/* Hidden Public Types                                                     */

#ifndef SCANNER_MODULE

typedef struct scan_str Scanner;

#endif

/*-------------------------------------------------------------------------*/
/* Public Types                                                            */

typedef enum token_id_enum {
    token_error_id,
    token_symbol_id,
    token_single_id,
    token_integer_id,
    token_float_id,
    token_eof_id
  } Token_id;

typedef struct token_str {
    Token_id id;
    char     *value;
} Token;

#include "scanner.pro"


    
    
    
