/**
 ** xdraw.h
 **
 ** Copyright 1990, 1991 by Randy Sargent.
 **
 ** The author hereby grants to MIT permission to use this software.
 ** The author also grants to MIT permission to distribute this software
 ** to schools for non-commercial educational use only.
 **
 ** The author hereby grants to other individuals or organizations
 ** permission to use this software for non-commercial
 ** educational use only.  This software may not be distributed to others
 ** except by MIT, under the conditions above.
 **
 ** Other than these cases, no part of this software may be used or
 ** distributed without written permission of the author.
 **
 ** Neither the author nor MIT make any representations about the 
 ** suitability of this software for any purpose.  It is provided 
 ** "as is" without express or implied warranty.
 **
 ** Randy Sargent
 ** Research Specialist
 ** MIT Media Lab
 ** 20 Ames St.  E15-301
 ** Cambridge, MA  02139
 ** E-mail:  rsargent@athena.mit.edu
 **
 **/

#ifndef XDRAW_H
#define XDRAW_H

#include <growbuf.h>

#include <X11/Xlib.h>
#include <X11/X.h>

typedef struct win_str {
    Display *display;
    Int screen;
    Drawable w;
    GC gc;
    Int width, height;
    double scale;
    Int arc, arc_x, arc_y, arc_diam, arc_beg, arc_span;
    Growbuf points;
    Int pixmap;
    Int disable;
    XColor *xcolor;
} Win;

extern XColor white_color, black_color;

#include "xdraw.pro"

#endif
